/* eslint-disable complexity */
/* eslint-disable max-depth */
/* eslint-disable prefer-const */
const Command = require('../../Structures/Command');
// const errors = require('../../utils/errors.js');
const config = require('../../../config.json');
const { MessageEmbed } = require('discord.js');

module.exports = class extends Command {

	constructor(...args) {
		super(...args, {
			category: 'Application'
		});
	}

	// eslint-disable-next-line no-unused-vars
	async run(message, args) {
		message.delete();
		const department = message.channel.topic.slice(21);
		const owner = message.channel.topic.slice(0, 18);
		const applying = [];
		const application = [];
		const cancelStat = new Map();

		if (message.author.id === owner) {
			for (const [key, value] of Object.entries(config.application_questions)) {
				if (key.toLowerCase() === department.toLowerCase()) {
					if (applying.includes(message.author.id)) return;

					try {
						for (const [keyCID2, valueCID2] of Object.entries(config.channel_ids)) {
							if (keyCID2.toLowerCase() === key.toLowerCase()) {
								const nChannel2 = message.guild.channels.cache.find(channel => channel.id === valueCID2);
								nChannel2.send(`${message.author.tag} began applying.`);
							}
						}

						applying.push(message.author.id);
						await message.channel.send(':pencil: **Application started!** Type `#cancel` to exit.');

						cancelStat.set('stat', 'false');
						for (let i = 0, canceled = false; i < value.length && canceled === false; i++) {
							await message.channel.send(`\n${value[i]}`);
							await message.channel.awaitMessages(msg => msg.author.id === message.author.id, { max: 1, time: 300000, errors: ['time'] })
								.then(async collected => {
									application[value[i]] = collected.first().content;

									if (collected.first().content.toLowerCase() === '#cancel') {
										await message.channel.send(':x: **Application cancelled.**');
										applying.splice(applying.indexOf(message.author.id), 1);
										canceled = true;
										if (canceled) {
											cancelStat.set('stat', 'true');
										}

										for (const [keyCID3, valueCID3] of Object.entries(config.channel_ids)) {
											if (keyCID3.toLowerCase() === key.toLowerCase()) {
												const nChannel3 = message.guild.channels.cache.find(channel => channel.id === valueCID3);
												nChannel3.send(`${message.author.tag} cancelled their application.`);
											}
										}
									}
								}).catch(async () => {
									await message.channel.send(':hourglass: **Application timed out.**');
									applying.splice(applying.indexOf(message.author.id), 1);
									canceled = true;
									if (canceled) {
										cancelStat.set('stat', 'true');
									}

									for (const [keyCID4, valueCID4] of Object.entries(config.channel_ids)) {
										if (keyCID4.toLowerCase() === key.toLowerCase()) {
											const nChannel4 = message.guild.channels.cache.find(channel => channel.id === valueCID4);
											nChannel4.send(`${message.author.tag} let their application time out.`);
										}
									}
								});
						}

						const cancel = cancelStat.get('stat');
						if (cancel === 'false') {
							await message.channel.send(':thumbsup: **Application Complete / Submitted!**');

							for (const [keyCID5, valueCID5] of Object.entries(config.channel_ids)) {
								if (keyCID5.toLowerCase() === key.toLowerCase()) {
									const nChannel5 = message.guild.channels.cache.find(channel => channel.id === valueCID5);
									await nChannel5.send(`${message.author.tag} finished applying.`);
								}
							}
						}
					} catch (err) {
						console.error(err);
					}

					const cancel = cancelStat.get('stat');
					if (cancel === 'false') {
						const nEmbed = new MessageEmbed()
							.setTitle(`Member Applied for ${this.client.utils.capitalise(key)}.`)
							.addField('User Info', [
								`**❯ User:** ${message.author}`,
								`**❯ Username:** ${message.author.username}`,
								`**❯ Discriminator:** ${message.author.discriminator}`,
								`**❯ ID:** ${message.author.id}`,
								'\u200b',
								`**Questions / Answers:**`,
								'\u200b'
							])
							.setTimestamp();
						for (const [keyC, valueC] of Object.entries(config.department_colors)) {
							if (keyC.toLowerCase() === key.toLowerCase()) {
								nEmbed.setColor(valueC);
							}
						}
						if (config.settings.enable_logo) {
							for (const [keyL, valueL] of Object.entries(config.department_logo)) {
								if (keyL.toLowerCase() === key.toLowerCase()) {
									nEmbed.setThumbnail(valueL);
								}
							}
						} else {
							nEmbed.setThumbnail('https://cdn3.iconfinder.com/data/icons/education-and-school-filled-outline-2/64/Education_FilledOutline21-512.png');
						}
						for (const [keyA, valueA] of Object.entries(application)) {
							nEmbed.addField(`Question: ${keyA}`, [
								`**Answer:**\n**❯**\u2000${valueA}`,
								'\u200b'
							]);
						}
						for (const [keyCID, valueCID] of Object.entries(config.channel_ids)) {
							nEmbed.setDescription('An application has been completed to the user below.\n All User and Question information is listed.');
							if (keyCID.toLowerCase() === key.toLowerCase()) {
								const nChannel = message.guild.channels.cache.find(channel => channel.id === valueCID);
								if (config.settings.notice_ping) {
									for (const [keyNP, valueNP] of Object.entries(config.role_ids)) {
										if (keyNP.toLowerCase() === key.toLowerCase()) {
											if (valueNP === '') {
												nChannel.send(nEmbed);
											} else {
												nChannel.send(`<@&${valueNP}>`, nEmbed);
											}
										}
									}
								} else {
									nChannel.send(nEmbed);
								}
								if (config.settings.all_app_logs) {
									const apChannel = message.guild.channels.cache.find(channel => channel.id === config.channel_ids.all_app_logs);
									if (config.settings.notice_ping) {
										for (const [keyNP, valueNP] of Object.entries(config.role_ids)) {
											if (keyNP.toLowerCase() === key.toLowerCase()) {
												if (valueNP === '') {
													apChannel.send(nEmbed);
												} else {
													apChannel.send(`<@&${valueNP}>`, nEmbed);
												}
											}
										}
									} else {
										apChannel.send(nEmbed);
									}
								}
							}
						}
					}
				}
			}
		} else {
			message.reply(`:x: **You must be the original applicant to use this command.**`);
		}
	}

};
