/* eslint-disable prefer-const */
const Command = require('../../Structures/Command');
// const errors = require('../../utils/errors.js');
const config = require('../../../config.json');

module.exports = class extends Command {

	constructor(...args) {
		super(...args, {
			description: `**Only Usable if DM Application Link System is disabled.**\nCloses the application channel.`,
			category: 'Application'
		});
	}

	// eslint-disable-next-line consistent-return
	async run(message) {
		message.delete();
		const owner = message.channel.topic.slice(0, 18);
		const supportRole = message.guild.roles.cache.find(rl => rl.id === config.role_ids.staff);
		const depHeadSee = config.settings.depHead_see_apps;
		const depHeadRole = message.guild.roles.cache.find(rl => rl.id === config.role_ids.depHead);
		const { channel } = message;
		if (!message.channel.name.startsWith(`application-`)) return message.channel.send(`Your not in a application channel.`).then(msg => msg.delete({ timeout: 10000 }));
		if (message.member.roles.cache.has(supportRole) || message.member.hasPermission('ADMINISTRATOR')) {
			await message.channel.send(`Do you want to close or delete this application channel?\nType **\`close\`** to close. \nType **\`delete\`** to delete.`);
			await message.channel.awaitMessages(msg => msg.author.id === message.author.id, {
				max: 1,
				time: 8000,
				errors: ['time']
			})
				// eslint-disable-next-line consistent-return
				.then(async collected => {
					if (collected.first().content === 'close') {
						if (depHeadSee) {
							channel.overwritePermissions([
								{
									id: message.author.id,
									deny: ['VIEW_CHANNEL', 'SEND_MESSAGES', 'MANAGE_MESSAGES']
								},
								{
									id: depHeadRole,
									allow: ['VIEW_CHANNEL', 'SEND_MESSAGES'],
									deny: ['MANAGE_MESSAGES']
								},
								{
									id: supportRole,
									allow: ['VIEW_CHANNEL', 'SEND_MESSAGES'],
									deny: ['MANAGE_MESSAGES']
								},
								{
									id: message.guild.id,
									deny: ['VIEW_CHANNEL', 'SEND_MESSAGES', 'MANAGE_MESSAGES']
								}
							], `Application channel closed by ${message.author}`);
						} else {
							channel.overwritePermissions([
								{
									id: message.author.id,
									deny: ['VIEW_CHANNEL', 'SEND_MESSAGES', 'MANAGE_MESSAGES']
								},
								{
									id: supportRole,
									allow: ['VIEW_CHANNEL', 'SEND_MESSAGES', 'MANAGE_MESSAGES']
								},
								{
									id: message.guild.id,
									deny: ['VIEW_CHANNEL', 'SEND_MESSAGES']
								}
							], `Application channel closed by ${message.author}`);
						}
						message.channel.send(`**Closed** | <@${owner}> can not longer see or type here.`);
					} else if (collected.first().content === 'delete') {
						await message.channel.send(`Finial Confirmation! You can not go back after this!\nType **\`yes\`** to delete this application channel. \nType **\`no\`** to cancel.`);
						await message.channel.awaitMessages(msg => msg.author.id === message.author.id, {
							max: 1,
							time: 10000,
							errors: ['time']
						})
						// eslint-disable-next-line consistent-return
							.then(collected2 => {
								if (collected2.first().content === 'yes') {
									message.channel.send('**Deleting in 5 seconds...**')
										.then(
											setTimeout(() => {
												channel.delete();
											}, 5000)
										);
								} else if (collected2.first().content === 'no') {
									message.channel.send('**Canceled.** | Application Channel will not be deleted.');
								}
							}).catch(() => {
								message.channel.send('**Timed Out.** | Application Channel will not be deleted.');
							});
					} else {
						message.channel.send(`**Invalid Input** | Application Channel will not be closed.`);
					}
				}).catch(() => {
					message.channel.send('**Timed Out.** | Application Channel will not be closed.');
				});
		} else {
			await message.channel.send(`Do you want to close this application channel?\nType **\`yes\`** to lock. \nType **\`no\`** to cancle.`);
			await message.channel.awaitMessages(msg => msg.author.id === message.author.id, {
				max: 1,
				time: 8000,
				errors: ['time']
			})
				// eslint-disable-next-line consistent-return
				.then(async collected => {
					if (collected.first().content === 'yes') {
						if (depHeadSee) {
							channel.overwritePermissions([
								{
									id: message.author.id,
									deny: ['VIEW_CHANNEL', 'SEND_MESSAGES', 'MANAGE_MESSAGES']
								},
								{
									id: depHeadRole,
									allow: ['VIEW_CHANNEL', 'SEND_MESSAGES'],
									deny: ['MANAGE_MESSAGES']
								},
								{
									id: supportRole,
									allow: ['VIEW_CHANNEL', 'SEND_MESSAGES'],
									deny: ['MANAGE_MESSAGES']
								},
								{
									id: message.guild.id,
									deny: ['VIEW_CHANNEL', 'SEND_MESSAGES', 'MANAGE_MESSAGES']
								}
							], `Application channel closed by ${message.author}`);
						} else {
							channel.overwritePermissions([
								{
									id: message.author.id,
									deny: ['VIEW_CHANNEL', 'SEND_MESSAGES', 'MANAGE_MESSAGES']
								},
								{
									id: supportRole,
									allow: ['VIEW_CHANNEL', 'SEND_MESSAGES', 'MANAGE_MESSAGES']
								},
								{
									id: message.guild.id,
									deny: ['VIEW_CHANNEL', 'SEND_MESSAGES']
								}
							], `Application channel closed by ${message.author}`);
						}
						message.channel.send(`**Closed** | ${owner} can not longer see or type here.`);
					} else if (collected.first().content === 'no') {
						message.channel.send('**Cancled.** | The application channel will not be closed.');
					} else {
						message.channel.send(`**Invalid Input** | Application Channel will not be closed.`);
					}
				}).catch(() => {
					message.channel.send('**Timed Out.** | Application Channel will not be closed.');
				});
		}
	}

};
