/* eslint-disable prefer-const */
const Command = require('../../Structures/Command');
// const errors = require('../../utils/errors.js');
const config = require('../../../config.json');
const { MessageEmbed } = require('discord.js');

module.exports = class extends Command {

	constructor(...args) {
		super(...args, {
			aliases: ['department'],
			description: `Get a list of all ${config.bot_setup.server_name}'s departments.`,
			category: 'Hiring'
		});
	}

	// eslint-disable-next-line no-unused-vars
	async run(message, args) {
		message.delete();
		const depNames = config.settings.department_names;
		const embed = new MessageEmbed()
			.setColor(config.bot_setup.main_embed_color)
			.setTitle(`${config.bot_setup.server_name} Department List`)
			.setDescription([
				`There are a total of **${depNames.length}** departments in ${config.bot_setup.server_name}.`,
				`Currently, **${config.settings.apps_open_dep_number}** departments with **open** applications.`,
				`Currently, **${config.settings.apps_closed_dep_number}** departments with **closed** applications.`,
				'\u200b'
			])
			.addField('All Departments', [
				`**❯**\u2000${depNames.join('\n**❯**\u2000')}`,
				'\u200b'
			])
			// Removal of the copyright below is a violation of the bot's licence!
			.setFooter(`Requested by ${message.author.username} | ©2020 - 2021 Agent Squad Productions`, message.author.displayAvatarURL({ dynamic: true }))
			.setTimestamp();

		if (config.settings.department_status_use) {
			for (const [key, value] of Object.entries(config.department_status)) {
				embed.addField(`${this.client.utils.capitalise(key)}'s Application Statuses`, [
					`**❯**\u2000${this.client.utils.capitalise(value)}`
				]);
			}
		}

		message.channel.send(embed);
	}

};
