/* eslint-disable max-depth */
/* eslint-disable prefer-const */
const Command = require('../../Structures/Command');
// const errors = require('../../utils/errors.js');
const config = require('../../../config.json');
const { MessageEmbed } = require('discord.js');

module.exports = class extends Command {

	constructor(...args) {
		super(...args, {
			aliases: ['departmentinfo', 'department-info', 'depinfo', 'dep-info'],
			usage: `(department)`,
			description: `Get information on all of ${config.bot_setup.server_name}'s departments.\n Do ${config.prefix}departments for a department list.`,
			category: 'Hiring'
		});
	}

	// eslint-disable-next-line no-unused-vars
	async run(message, args) {
		message.delete();
		const embed = new MessageEmbed()
			.setTitle(`${config.bot_setup.server_name}, Department Information Center`)
			.setDescription([`Get information about any of the **${config.settings.department_names.length}** departments in ${config.bot_setup.server_name}.`, '\u200b'])
			// Removal of the copyright below is a violation of the bot's licence!
			.setFooter(`Requested by ${message.author.username} | ©2020 - 2021 Agent Squad Productions`, message.author.displayAvatarURL({ dynamic: true }))
			.setTimestamp();

		const depInfo = args.join(' ').toLowerCase();

		const figDepDesc = config.department_info;
		const depDescKeys = Object.keys(figDepDesc);

		let infoNull = new Map();
		infoNull.set('stat', 'true');

		for (const deptDesc of depDescKeys) {
			if (depInfo === deptDesc.toLowerCase()) {
				infoNull.set('stat', 'false');
				for (const [key, value] of Object.entries(config.department_info)) {
					if (key.toLowerCase() === deptDesc.toLowerCase()) {
						embed.setTitle(`${config.bot_setup.server_name}, Department Information`)
							.addField(`${this.client.utils.capitalise(deptDesc)}'s Description`, [
								`**❯** ${value}`,
								'\u200b'
							]);
						for (const [keyC, valueC] of Object.entries(config.department_colors)) {
							if (keyC.toLowerCase() === deptDesc.toLowerCase()) {
								embed.setColor(valueC);
							}
						}
						if (config.settings.enable_logo) {
							for (const [keyL, valueL] of Object.entries(config.department_logo)) {
								if (keyL.toLowerCase() === deptDesc.toLowerCase()) {
									embed.setThumbnail(valueL);
								}
							}
						} else {
							embed.setThumbnail(message.guild.iconURL({ dynamic: true }));
						}
					}
				}
			}
		}

		const nullStat = infoNull.get('stat');
		if (nullStat === 'true') {
			embed.addField('Command Information', [
				`**❯** To get a **list of all the departments** you will need to do \`\`${config.prefix}departments\`\`.`,
				`**❯** __**You must enter a name of a department in the department list.**__ \n\u2000*(Capitalization does not matter, but spelling does.)*`,
				'\u200b'
			])
				.setColor(config.bot_setup.main_embed_color)
				.setThumbnail(message.guild.iconURL({ dynamic: true }))
				.addField('Command Usage', [
					`**❯** You would do \`\`${config.prefix}info\`\` followed by the name of a department.`,
					`**❯** Make sure to not put to many spaces or any unusual characters within the command.`,
					// eslint-disable-next-line max-len
					`**❯** If the command gets eaten, aka you do it and nothing happens at all do one of the follow:\n\u2000 1) Make Sure everything is spelled correctly.\n\u2000 2) Make sure the Owner has the bot set up correctly.`,
					// eslint-disable-next-line max-len
					`**❯** Examples:\n\u2000**•** \`\`${config.prefix}info police\`\`\n\u2000**•** \`\`${config.prefix}info fire rescue\`\`\n\u2000**•** \`\`${config.prefix}info Sheriff's office\`\`\n\u2000**Example Note:** The department's in the example commands are examples and not ones set by the server. (Do the departments command to get the real list!)`
				]);
		}

		message.channel.send(embed);
	}

};
