/* eslint-disable complexity */
/* eslint-disable max-depth */
/* eslint-disable prefer-const */
const Command = require('../../Structures/Command');
// const errors = require('../../utils/errors.js');
const config = require('../../../config.json');
const { MessageEmbed } = require('discord.js');
const colors = require('../../../colors.json');

module.exports = class extends Command {

	constructor(...args) {
		super(...args, {
			aliases: ['apply'],
			usage: `(department)`,
			description: `Apply to join a department.\n Use \`\`${config.prefix}departments\`\` to get a list of all departments.`,
			category: 'Hiring'
		});
	}

	// eslint-disable-next-line no-unused-vars
	async run(message, args) {
		message.delete();
		const user = message.author;
		const depName = args.join(' ').toLowerCase();
		const depNamesCon = config.department_status;

		let nameNull = new Map();
		nameNull.set('stat', 'true');

		const cmdChannel = message.guild.channels.cache.find(ch => ch.id === config.channel_ids.hiringCMD);
		if (config.settings.restrict_cmd_channel && message.channel !== cmdChannel) {
			const eEmbed = new MessageEmbed()
				.setColor(colors.redlight)
				.setTitle('That command is restricted to only one channel.')
				.addField('Correct Channel:', `Head to ${cmdChannel}.`);
			message.channel.send(`${user},`, eEmbed)
				.then(msg => msg.delete({ timeout: 8000 }))
				.catch(console.error);
		} else {
			for (const [key, value] of Object.entries(depNamesCon)) {
				if (depName === key.toLowerCase() && value.toLowerCase() !== 'closed') {
					nameNull.set('stat', 'false');
					const aEmbed = new MessageEmbed()
						.setTitle(`${this.client.utils.capitalise(key)} Application Information / Link`)
						// Removal of the copyright below is a violation of the bot's licence!
						.setFooter(`${config.bot_setup.server_name}, Hiring Bot | ©2020 - 2021 Agent Squad Productions`)
						.setDescription([
							`Thank you for your interest in joining the ${this.client.utils.capitalise(key)}!`,
							'\u200b'
						])
						.setTimestamp();
					const nEmbed = new MessageEmbed()
						.setTitle(`Member Applied for ${this.client.utils.capitalise(key)}.`)
						.addField('User Info', [
							`**❯ User:** ${message.author}`,
							`**❯ Username:** ${message.author.username}`,
							`**❯ Discriminator:** ${message.author.discriminator}`,
							`**❯ ID:** ${message.author.id}`
						])
						.setTimestamp();
					for (const [keyI, valueI] of Object.entries(config.department_info)) {
						if (keyI.toLowerCase() === key.toLowerCase()) {
							aEmbed.addField('Department Information', [
								`**❯** ${valueI}`,
								'\u200b'
							]);
						}
					}
					if (config.settings.preAppMSG) {
						for (const [keyAMSG, valueAMSG] of Object.entries(config.department_aplicantMSG)) {
							if (keyAMSG.toLowerCase() === key.toLowerCase()) {
								aEmbed.addField('Pre-Application Information', [
									`**❯** ${valueAMSG}`,
									'\u200b'
								]);
							}
						}
					}
					if (config.settings.DMAppLink) {
						for (const [keyAL, valueAL] of Object.entries(config.department_appLink)) {
							if (keyAL.toLowerCase() === key.toLowerCase()) {
								aEmbed.addField('Application Link', [
									`**❯** ${valueAL}`,
									'\u200b'
								]);
							}
						}
					}
					for (const [keyC, valueC] of Object.entries(config.department_colors)) {
						if (keyC.toLowerCase() === key.toLowerCase()) {
							aEmbed.setColor(valueC);
							nEmbed.setColor(valueC);
						}
					}
					if (config.settings.enable_logo) {
						for (const [keyL, valueL] of Object.entries(config.department_logo)) {
							if (keyL.toLowerCase() === key.toLowerCase()) {
								aEmbed.setThumbnail(valueL);
								nEmbed.setColor(valueL);
							}
						}
					} else {
						nEmbed.setThumbnail('https://cdn3.iconfinder.com/data/icons/education-and-school-filled-outline-2/64/Education_FilledOutline21-512.png');
						nEmbed.setThumbnail('https://cdn3.iconfinder.com/data/icons/education-and-school-filled-outline-2/64/Education_FilledOutline21-512.png');
					}

					if (config.settings.DMAppLink) {
						message.reply('Check your DMs from me for the application information / link!').then(msg => msg.delete({ timeout: 8000 }));
						this.client.users.cache.get(`${message.author.id}`).send(aEmbed);
						nEmbed.setDescription('An application has been DMed to the user below.');
						for (const [keyCID, valueCID] of Object.entries(config.channel_ids)) {
							if (keyCID.toLowerCase() === key.toLowerCase()) {
								const nChannel = message.guild.channels.cache.find(channel => channel.id === valueCID);
								if (config.settings.notice_ping) {
									for (const [keyNP, valueNP] of Object.entries(config.role_ids)) {
										if (keyNP.toLowerCase() === key.toLowerCase()) {
											if (valueNP === '') {
												nChannel.send(nEmbed);
											} else {
												nChannel.send(`<@&${valueNP}>`, nEmbed);
											}
										}
									}
								} else {
									nChannel.send(nEmbed);
								}
								if (config.settings.all_app_logs) {
									const apChannel = message.guild.channels.cache.find(channel => channel.id === config.channel_ids.all_app_logs);
									if (config.settings.notice_ping) {
										for (const [keyNP, valueNP] of Object.entries(config.role_ids)) {
											if (keyNP.toLowerCase() === key.toLowerCase()) {
												if (valueNP === '') {
													apChannel.send(nEmbed);
												} else {
													apChannel.send(`<@&${valueNP}>`, nEmbed);
												}
											}
										}
									} else {
										apChannel.send(nEmbed);
									}
								}
							}
						}
					} else {
						aEmbed.addField('Application Information', [
							`**❯** To being your application do \`\`${config.prefix}apply\`\`.`,
							`**❯** You must be the original applicant to run the apply command.`,
							`**❯** Once you start your application you will be given 10 minutes to answer each question, or the prosses will end.`,
							`**❯** If the appliation process ends, redo the command and it will start again. *(From the start.)*`,
							`**❯** If an error occurs doing the application process try to contact the bot Owner or ASP Team.`,
							'\u200b'
						])
							.addField('Notes', [
								`Do not remove or change this channel's topic as it is important for other functions.`,
								`Do not remove the \`\`application-\`\` from the channel command or other commands may not work.`
							]);
						const depHeadSee = config.settings.depHead_see_apps;
						const depHeadRole = message.guild.roles.cache.find(rl => rl.id === config.role_ids.depHead);
						const cat = config.channel_ids.app_category;
						const supportRole = message.guild.roles.cache.find(rl => rl.id === config.role_ids.staff);
						message.guild.channels.create(`application-${message.author.tag}`).then(ticcat => {
							moveTicket(ticcat);
							if (depHeadSee) {
								ticcat.overwritePermissions([
									{
										id: message.author.id,
										allow: ['VIEW_CHANNEL', 'SEND_MESSAGES'],
										deny: ['MANAGE_MESSAGES']
									},
									{
										id: depHeadRole,
										allow: ['VIEW_CHANNEL', 'SEND_MESSAGES'],
										deny: ['MANAGE_MESSAGES']
									},
									{
										id: supportRole,
										allow: ['VIEW_CHANNEL', 'SEND_MESSAGES'],
										deny: ['MANAGE_MESSAGES']
									},
									{
										id: message.guild.id,
										deny: ['VIEW_CHANNEL', 'SEND_MESSAGES', 'MANAGE_MESSAGES']
									}
								], 'Application Channel Setup');
							} else {
								ticcat.overwritePermissions([
									{
										id: message.author.id,
										allow: ['VIEW_CHANNEL', 'SEND_MESSAGES'],
										deny: ['MANAGE_MESSAGES']
									},
									{
										id: supportRole,
										allow: ['VIEW_CHANNEL', 'SEND_MESSAGES', 'MANAGE_MESSAGES']
									},
									{
										id: message.guild.id,
										deny: ['VIEW_CHANNEL', 'SEND_MESSAGES']
									}
								], 'Application Channel Setup');
							}
							ticcat.setTopic(`${message.author.id} | ${this.client.utils.capitalise(key)}`);
							ticcat.send(`<@${message.author.id}>, Please read the information below then begin your application.`, aEmbed);
							message.channel.send(`:white_check_mark: **<@${message.author.id}>, fill out your application in <#${ticcat.id}>.**`).then(msg => msg.delete({ timeout: 15000 }));
						});
						// eslint-disable-next-line no-inner-declarations
						async function moveTicket(ticcat) {
							await ticcat.setParent(cat);
						}
					}
				}
			}

			const nullStat = nameNull.get('stat');
			if (nullStat === 'true') {
				const nEmbed = new MessageEmbed()
					.setColor(colors.redlight)
					.setTitle(`${this.client.utils.capitalise(depName)} is not a valid department or applications are not open for it.`)
					.setDescription(`Please do \`\`${config.prefix}departments\`\` to find out the available departments.`);
				message.channel.send(`${user},`, nEmbed)
					.then(msg => msg.delete({ timeout: 8000 }))
					.catch(console.error);
			}
		}
	}

};
