const Command = require('../../Structures/Command');
const config = require('../../../config.json');
const { MessageEmbed } = require('discord.js');

module.exports = class extends Command {

	constructor(...args) {
		super(...args, {
			description: 'Check the bot\'s prefix.',
			category: 'Utility'
		});
	}

	// eslint-disable-next-line consistent-return
	async run(message) {
		try {
			message.delete();
			const embed = new MessageEmbed()
				.setTitle(`Bot Prefixes`)
				.setColor(config.bot_setup.main_embed_color)
				.setFooter(`Requested by: ${message.author.tag}`)
				.setTimestamp()
				.setDescription([
					`**1)**\u2000${config.prefix}`,
					`**2)**\u2000<@${this.client.user.id}>`
				]);
			message.channel.send(embed).then(msg => msg.delete({ timeout: 120000 }));
		} catch (err) {
			console.log(err);
		}
	}

};
